function drawInnerGround()
	love.graphics.setCanvas(groundInner)

	for x = 1, #floor[1] do
		for y = 1, #floor do
			love.graphics.setColor(255,255,255,255)

			local iId = floor[x][y]
			if iId == 0 then iId = 1 end

			love.graphics.draw(img[1], x * textureWidth, y * textureHeight)
		end
	end
	love.graphics.setCanvas()
end

function processFloor()
	local x, y, a, ox, oy = ground:getWidth() / 2, ground:getHeight(), -getPlayerRot() - math.rad(90), player.posY * textureWidth, player.posX * textureHeight

	love.graphics.setCanvas(ground)
	ground:clear(0,0,0)

	love.graphics.setColor(255,255,255)
	love.graphics.draw(groundInner, x, y, a, 1, 1, ox, oy)
	love.graphics.setCanvas()
end

function drawFloor()
	screenC:clear()
	love.graphics.setCanvas(screenC)

	local ss = 1 / pixelScale
	
	local fy0 = furthestBottom
	local rayScreenPos = furthestWall
	local rayViewDist = math.sqrt(rayScreenPos * rayScreenPos + viewDist * viewDist)
	local rayAngle = math.asin(rayScreenPos / rayViewDist)
	local cosAng = math.cos(rayAngle)

	for y = fy0, h do
		if cosAng == 0 then cosAng = 0.0001 end
		local dist = ((viewDist * ((textureWidth * (1 - eyeHeight)))/(y - h * eyeHeight)) / cosAng) / textureHeight

		local size = rayViewDist / dist / textureHeight * pixelScale

		local q = math.floor(dist * textureHeight)
		if q > 2047 then q = 2047 end
		if q < 0 then q = 0 end

		local deathColor = 1 - (dist / maxFogDist)
		if deathColor < 0 then deathColor = 0 end

		love.graphics.setColor(255 * deathColor, 255 * deathColor, 255 * deathColor)
		
		if groundQuad[q] then
			love.graphics.draw(ground, groundQuad[q], (w / 2) * ss, y, 0, size, 1, 1024 * ss, 0)
		end
	end
	love.graphics.setCanvas()
	
	drawSky()
	love.graphics.draw(screenC)
	-- love.graphics.draw(screenC, 0, love.graphics.getHeight(), 0, 1, -1)
end

function drawSky()
	local pi = math.pi
    local ss = 1 / pixelScale
	local sx = -((skyImg:getWidth() / (pi * 2)) * (getPlayerRot() % (pi * 2)))
	local sy = 0

	for i = -1, 1 do
	    love.graphics.setColor(255, 255, 255)
		love.graphics.draw(skyImg, sx + (skyImg:getWidth() * i), sy, 0, 1 / pixelScale, 1 / pixelScale)
	end
end